



#define FCY		8000000UL		//Fosc/4    (Fosc = 32MHz)
// Tcy = 0.0625us

#define HSYNC	LATAbits.LATA0
#define VSYNC	LATAbits.LATA1
#define CHARGE	LATAbits.LATA3
#define SOUND	LATAbits.LATA4

#define BTN1	PORTBbits.RB15	// button 1
#define BTN2	PORTBbits.RB14	// button 2
#define R_BTN	PORTBbits.RB13	// right button
#define U_BTN	PORTBbits.RB10	// up button
#define D_BTN	PORTBbits.RB12	// down button
#define L_BTN	PORTBbits.RB11	// left button

#define H_SIZE	45
#define V_SIZE	45

#define HEAD	0x10	// ̐Fiԁj
#define BODY	0x40	// ̂̐Fij
#define FOOD	0x50	// a̐Fi}[^j
#define FOOD_NUM	50	// a̐



///////////////////// GLOBAL VARIABLES


unsigned char *pointer1;



unsigned int t1_icnt;	// TMR1荞݉񐔂̃JE^
unsigned char t1_iflg;	// TMR1荞݂̃tO

unsigned char tdisp;	// pat[][] ̃f[^\ 1
unsigned char pat[V_SIZE][H_SIZE + 1];	// ʕ\p^[̃f[^z
unsigned char dummy[H_SIZE + 1];	// _~[z

unsigned char h_timing;

unsigned char number[10][11]={	// ̃hbgf[^
	{0x3C,	//"0"
	 0x7E,
	 0x66,
	 0x66,
	 0x66,
	 0x66,
	 0x66,
	 0x66,
	 0x66,
	 0x7E,
	 0x3C},

	{0x18,	//"1"
	 0x38,
	 0x18,
	 0x18,
	 0x18,
	 0x18,
	 0x18,
	 0x18,
	 0x18,
	 0x3C,
	 0x3C},
	 
	{0x3C,	//"2"
	 0x7E,
	 0x66,
	 0x06,
	 0x0C,
	 0x18,
	 0x30,
	 0x60,
	 0x60,
	 0x7E,
	 0x7E},
	 
	{0x3C,	//"3"
	 0x7E,
	 0x66,
	 0x06,
	 0x0C,
	 0x18,
	 0x0C,
	 0x06,
	 0x66,
	 0x7E,
	 0x3C},
	 
	{0x0C,	//"4"
	 0x1C,
	 0x1C,
	 0x3C,
	 0x2C,
	 0x6C,
	 0x4C,
	 0xFE,
	 0xFE,
	 0x0C,
	 0x0C},
	 
	{0x7E,	//"5"
	 0x7E,
	 0x60,
	 0x60,
	 0x7C,
	 0x7E,
	 0x66,
	 0x06,
	 0x66,
	 0x7E,
	 0x3C},

	{0x3C,	//"6"
	 0x7E,
	 0x66,
	 0x60,
	 0x7C,
	 0x7E,
	 0x66,
	 0x66,
	 0x66,
	 0x7E,
	 0x3C},
	 
	{0x7E,	//"7"
	 0x7E,
	 0x66,
	 0x06,
	 0x06,
	 0x0C,
	 0x0C,
	 0x18,
	 0x18,
	 0x18,
	 0x18},
	 
	{0x3C,	//"8"
	 0x7E,
	 0x66,
	 0x66,
	 0x3C,
	 0x3C,
	 0x66,
	 0x66,
	 0x66,
	 0x7E,
	 0x3C},

	{0x3C,	//"9"
	 0x7E,
	 0x66,
	 0x66,
	 0x66,
	 0x7E,
	 0x3E,
	 0x06,
	 0x66,
	 0x7E,
	 0x3C}
};	 
	 







///////////////////////////////////////////////////////////////////////////////
void disp_frame(void){

	unsigned char j,k;

		while(!tdisp);
		while(t1_icnt<40);	// back porch of vertical scan

		CHARGE = 1;		// RN^̏[d~
		IEC0bits.T2IE = 0;		//
		pointer1 = pat;

		
		for(k=0; k<V_SIZE; k++){	// vertically 50 blocks 

			for(j=0; j<10; j++){
				
				// raster 1
				t1_iflg = 0;
				while(!t1_iflg);	// wait for HSYNC
				__delay32(h_timing);	//delay "h_timing" instruction cycles (8 cycles -> 1us)

				LATB = *pointer1;	// H_SIZE ̉񐔃f[^o
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;

				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;

				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;

				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;


				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;
				LATB = *pointer1;
				pointer1++;

				//
				LATB = *pointer1;	//@E[
		//		pointer1++;
				pointer1 -= 45;
				
			}
				
			pointer1 += 46;

		}



		tdisp = 0;
		IEC0bits.T2IE = 1;		//
		

}// end of 1 frame display 


